#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_TSL2561.h>  
Adafruit_TSL2561_Unified tsl = Adafruit_TSL2561_Unified(TSL2561_ADDR_FLOAT, 00002);
uint16_t broadband = 0;
uint16_t infrared = 0;

int led1  = 1;
int led2  = 0;
int led3  = 4;
int led4  = 5;
int led5  = 6;
int led6  = 7;
int led7  = 8;
int led8  = 9;
int led9  = 10;
int led10 = 11;
int led11 = 12;
int led12 = 13;

unsigned int tsl1current =0;
unsigned int tsl2current =0;
unsigned int tsl3current =0;
unsigned int tsl4current =0;
unsigned int tsl5current =0;
unsigned int tsl6current =0;
unsigned int tsl7current =0;
unsigned int tsl8current =0;
unsigned int tsl9current =0;
unsigned int tsl10current =0;
unsigned int tsl11current =0;
unsigned int tsl12current =0;
unsigned int tsl1max = 0;
unsigned int tsl2max = 0;
unsigned int tsl3max = 0;
unsigned int tsl4max = 0;
unsigned int tsl5max = 0;
unsigned int tsl6max = 0;
unsigned int tsl7max = 0;
unsigned int tsl8max = 0;
unsigned int tsl9max = 0;
unsigned int tsl10max = 0;
unsigned int tsl11max = 0;
unsigned int tsl12max = 0;
float tsl1val =0;
float tsl2val =0;
float tsl3val =0;
float tsl4val =0;
float tsl5val =0;
float tsl6val =0;
float tsl7val =0;
float tsl8val =0;
float tsl9val =0;
float tsl10val =0;
float tsl11val =0;
float tsl12val =0;

//Mux control pins
int s0 = A0;
int s1 = A1;
int s2 = A2;
int s3 = A3;


void configureSensor(void)
{
   tsl.setGain(TSL2561_GAIN_16X);     /* 16x gain ... use in low light to boost sensitivity */
   tsl.setIntegrationTime(TSL2561_INTEGRATIONTIME_402MS);  /* 16-bit data but slowest conversions */  
}



void setup(void) 
{
  Serial.begin(9600);  
  
  pinMode(led1, OUTPUT);
  pinMode(led2, OUTPUT);
  pinMode(led3, OUTPUT);
  pinMode(led4, OUTPUT);
  pinMode(led5, OUTPUT);
  pinMode(led6, OUTPUT);
  pinMode(led7, OUTPUT);
  pinMode(led8, OUTPUT);
  pinMode(led9, OUTPUT);
  pinMode(led10, OUTPUT);
  pinMode(led11, OUTPUT);
  pinMode(led12, OUTPUT);
  
  pinMode(s0, OUTPUT); 
  pinMode(s1, OUTPUT); 
  pinMode(s2, OUTPUT); 
  pinMode(s3, OUTPUT); 

  digitalWrite(s0, HIGH);
  digitalWrite(s1, HIGH);
  digitalWrite(s2, LOW);
  digitalWrite(s3, LOW);  
  configureSensor();  /*mux3 Setup the sensor gain and integration time */

  digitalWrite(s0, LOW);
  digitalWrite(s1, LOW);
  digitalWrite(s2, HIGH);
  digitalWrite(s3, LOW);
  configureSensor();  /*mux4 Setup the sensor gain and integration time */

  digitalWrite(s0, HIGH);
  digitalWrite(s1, LOW);
  digitalWrite(s2, HIGH);
  digitalWrite(s3, LOW);
  configureSensor();  /*mux5 Setup the sensor gain and integration time */

  digitalWrite(s0, LOW);
  digitalWrite(s1, HIGH);
  digitalWrite(s2, HIGH);
  digitalWrite(s3, LOW); 
  configureSensor();  /*mux6 Setup the sensor gain and integration time */

  digitalWrite(s0, HIGH);
  digitalWrite(s1, HIGH);
  digitalWrite(s2, HIGH);
  digitalWrite(s3, LOW); 
  configureSensor();  /*mux7 Setup the sensor gain and integration time */

  digitalWrite(s0, LOW);
  digitalWrite(s1, LOW);
  digitalWrite(s2, LOW);
  digitalWrite(s3, HIGH);
  configureSensor();  /*mux8 Setup the sensor gain and integration time */
 
  digitalWrite(s0, HIGH);
  digitalWrite(s1, LOW);
  digitalWrite(s2, LOW);
  digitalWrite(s3, HIGH);
  configureSensor();  /*mux9 Setup the sensor gain and integration time */
 
  digitalWrite(s0, LOW);
  digitalWrite(s1, HIGH);
  digitalWrite(s2, LOW);
  digitalWrite(s3, HIGH);
  configureSensor();  /*mux10 Setup the sensor gain and integration time */

  digitalWrite(s0, HIGH);
  digitalWrite(s1, HIGH);
  digitalWrite(s2, LOW);
  digitalWrite(s3, HIGH);
  configureSensor();  /*mux11 Setup the sensor gain and integration time */
 
  digitalWrite(s0, LOW);
  digitalWrite(s1, LOW);
  digitalWrite(s2, HIGH);
  digitalWrite(s3, HIGH); 
  configureSensor();  /*mux12 Setup the sensor gain and integration time */
 
  digitalWrite(s0, HIGH);
  digitalWrite(s1, LOW);
  digitalWrite(s2, HIGH);
  digitalWrite(s3, HIGH);
  configureSensor();  /*mux13 Setup the sensor gain and integration time */

  digitalWrite(s0, LOW);
  digitalWrite(s1, HIGH);
  digitalWrite(s2, HIGH);
  digitalWrite(s3, HIGH);
  configureSensor();  /*mux14 Setup the sensor gain and integration time */
  
}




void loop(void) 
{  
  sensors_event_t event;
  Serial.print("DATA,");
  digitalWrite(s0, HIGH);
  digitalWrite(s1, HIGH);
  digitalWrite(s2, LOW);
  digitalWrite(s3, LOW);  
  digitalWrite(led1, HIGH);
  tsl.getEvent(&event);    // Get a new sensor event  
  tsl.getLuminosity (&broadband, &infrared); // Populate broadband with the latest values 
  tsl1current=broadband;   
  Serial.print(broadband);
  Serial.print(", ");
  digitalWrite(led1, LOW);
    if (broadband > tsl1max)
    { tsl1max=broadband;
    }

  digitalWrite(s0, LOW);
  digitalWrite(s1, LOW);
  digitalWrite(s2, HIGH);
  digitalWrite(s3, LOW);
  digitalWrite(led2, HIGH);
  tsl.getEvent(&event);    // Get a new sensor event  
  tsl.getLuminosity (&broadband, &infrared); // Populate broadband with the latest values  
  tsl2current=broadband;
  Serial.print(broadband);
  Serial.print(", ");
  digitalWrite(led2, LOW);
  if (broadband > tsl2max)
    { tsl2max=broadband;
    }

  digitalWrite(s0, HIGH);
  digitalWrite(s1, LOW);
  digitalWrite(s2, HIGH);
  digitalWrite(s3, LOW);
  digitalWrite(led3, HIGH);
  tsl.getEvent(&event);    // Get a new sensor event  
  tsl.getLuminosity (&broadband, &infrared); // Populate broadband infrared with the latest values  
  tsl3current=(broadband);
  Serial.print(broadband);
  Serial.print(", ");
  digitalWrite(led3, LOW); 
  if (broadband > tsl3max)
    { tsl3max=broadband;
    }

  digitalWrite(s0, LOW);
  digitalWrite(s1, HIGH);
  digitalWrite(s2, HIGH);
  digitalWrite(s3, LOW); 
  digitalWrite(led4, HIGH);
  tsl.getEvent(&event);    // Get a new sensor event  
  tsl.getLuminosity (&broadband, &infrared); // Populate broadband with the latest values
  tsl4current=(broadband);  
  Serial.print(broadband);
  Serial.print(", ");
  digitalWrite(led4, LOW);
  if (broadband > tsl4max)
    { tsl4max=broadband;
    }

  digitalWrite(s0, HIGH);
  digitalWrite(s1, HIGH);
  digitalWrite(s2, HIGH);
  digitalWrite(s3, LOW); 
  digitalWrite(led5, HIGH);
  tsl.getEvent(&event);    // Get a new sensor event  
  tsl.getLuminosity (&broadband, &infrared); // Populate broadband with the latest values  
  tsl5current=(broadband);
  Serial.print(broadband);
  Serial.print(", ");
  digitalWrite(led5, LOW);
  if (broadband > tsl5max)
    { tsl5max=broadband;
    }

  digitalWrite(s0, LOW);
  digitalWrite(s1, LOW);
  digitalWrite(s2, LOW);
  digitalWrite(s3, HIGH);
  digitalWrite(led6, HIGH);
  tsl.getEvent(&event);    // Get a new sensor event  
  tsl.getLuminosity (&broadband, &infrared); // Populate broadband infrared with the latest values  
  tsl6current=(broadband);
  Serial.print(broadband);
  Serial.print(", ");
  digitalWrite(led6, LOW);
 if (broadband > tsl6max)
    { tsl6max=broadband;
    } 
 
  digitalWrite(s0, HIGH);
  digitalWrite(s1, LOW);
  digitalWrite(s2, LOW);
  digitalWrite(s3, HIGH);
  digitalWrite(led7, HIGH);
  tsl.getEvent(&event);    // Get a new sensor event  
  tsl.getLuminosity (&broadband, &infrared); // Populate broadband with the latest values  
  tsl7current=(broadband);
  Serial.print(broadband);
  Serial.print(", ");
  digitalWrite(led7, LOW);
  if (broadband > tsl7max)
    { tsl7max=broadband;
    }
 
  digitalWrite(s0, LOW);
  digitalWrite(s1, HIGH);
  digitalWrite(s2, LOW);
  digitalWrite(s3, HIGH);
  digitalWrite(led8, HIGH);
  tsl.getEvent(&event);    // Get a new sensor event  
  tsl.getLuminosity (&broadband, &infrared); // Populate broadband with the latest values  
  tsl8current=(broadband);
  Serial.print(broadband);
  Serial.print(", ");
  digitalWrite(led8, LOW);
  if (broadband > tsl8max)
    { tsl8max=broadband;
    }

  digitalWrite(s0, HIGH);
  digitalWrite(s1, HIGH);
  digitalWrite(s2, LOW);
  digitalWrite(s3, HIGH);
  digitalWrite(led9, HIGH);
  tsl.getEvent(&event);    // Get a new sensor event  
  tsl.getLuminosity (&broadband, &infrared); // Populate broadband infrared with the latest values  
  tsl9current=(broadband);
  Serial.print(broadband);
  Serial.print(", ");
  digitalWrite(led9, LOW);
  if (broadband > tsl9max)
    { tsl9max=broadband;
    } 
 
  digitalWrite(s0, LOW);
  digitalWrite(s1, LOW);
  digitalWrite(s2, HIGH);
  digitalWrite(s3, HIGH); 
  digitalWrite(led10, HIGH);
  tsl.getEvent(&event);    // Get a new sensor event  
  tsl.getLuminosity (&broadband, &infrared); // Populate broadband with the latest values  
  tsl10current=(broadband);
  Serial.print(broadband);
  Serial.print(", ");
  digitalWrite(led10, LOW);
  if (broadband > tsl10max)
    { tsl10max=broadband;
    }
 
  digitalWrite(s0, HIGH);
  digitalWrite(s1, LOW);
  digitalWrite(s2, HIGH);
  digitalWrite(s3, HIGH);
  digitalWrite(led11, HIGH);
  tsl.getEvent(&event);    // Get a new sensor event  
  tsl.getLuminosity (&broadband, &infrared); // Populate broadband with the latest values 
  tsl11current=(broadband); 
  Serial.print(broadband);
  Serial.print(", ");
  digitalWrite(led11, LOW);
  if (broadband > tsl11max)
    { tsl11max=broadband;
    }

  digitalWrite(s0, LOW);
  digitalWrite(s1, HIGH);
  digitalWrite(s2, HIGH);
  digitalWrite(s3, HIGH);
  digitalWrite(led12, HIGH);
  tsl.getEvent(&event);    // Get a new sensor event  
  tsl.getLuminosity (&broadband, &infrared); // Populate broadband infrared with the latest values  
  tsl12current=(broadband);
  Serial.print(broadband);
  Serial.print(",      ");
  digitalWrite(led12, LOW);
  if (broadband > tsl12max)
    { tsl12max=broadband;
    }  
  
  tsl1val=(float)tsl1current/(float)tsl1max;
  tsl1val=100*tsl1val;
  tsl1val=100-tsl1val;
  Serial.print(tsl1val);
  Serial.print(", ");
  tsl2val=(float)tsl2current/(float)tsl2max;
  tsl2val=100*tsl2val;
  tsl2val=100-tsl2val;
  Serial.print(tsl2val);
  Serial.print(", ");
  tsl3val=(float)tsl3current/(float)tsl3max;
  tsl3val=100*tsl3val;
  tsl3val=100-tsl3val;
  Serial.print(tsl3val);
  Serial.print(", ");
  tsl4val=(float)tsl4current/(float)tsl4max;
  tsl4val=100*tsl4val;
  tsl4val=100-tsl4val;
  Serial.print(tsl4val);
  Serial.print(", ");
  tsl5val=(float)tsl5current/(float)tsl5max;
  tsl5val=100*tsl5val;
  tsl5val=100-tsl5val;
  Serial.print(tsl5val);
  Serial.print(", ");
  tsl6val=(float)tsl6current/(float)tsl6max;
  tsl6val=100*tsl6val;
  tsl6val=100-tsl6val;
  Serial.print(tsl6val); 
  Serial.print(", ");  
  tsl7val=(float)tsl7current/(float)tsl7max;
  tsl7val=100*tsl7val;
  tsl7val=100-tsl7val;
  Serial.print(tsl7val);
  Serial.print(", ");
  tsl8val=(float)tsl8current/(float)tsl8max;
  tsl8val=100*tsl8val;
  tsl8val=100-tsl8val;
  Serial.print(tsl8val);
  Serial.print(", ");
  tsl9val=(float)tsl9current/(float)tsl9max;
  tsl9val=100*tsl9val;
  tsl9val=100-tsl9val;
  Serial.print(tsl9val);
  Serial.print(", ");
  tsl10val=(float)tsl10current/(float)tsl10max;
  tsl10val=100*tsl10val;
  tsl10val=100-tsl10val;
  Serial.print(tsl10val);
  Serial.print(", ");
  tsl11val=(float)tsl11current/(float)tsl11max;
  tsl11val=100*tsl11val;
  tsl11val=100-tsl11val;
  Serial.print(tsl11val);
  Serial.print(", ");
  tsl12val=(float)tsl12current/(float)tsl12max;
  tsl12val=100*tsl12val;
  tsl12val=100-tsl12val;
  Serial.println(tsl12val); 
  
  delay(10000-9727);  //delay time in milliseconds - 9727ms(readout time for the 12 sensors)
}
